/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the ChannelTagsInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ChannelTagsInner{}

// ChannelTagsInner struct for ChannelTagsInner
type ChannelTagsInner struct {
	Id *string `json:"id,omitempty"`
	Name *string `json:"name,omitempty"`
}

// NewChannelTagsInner instantiates a new ChannelTagsInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewChannelTagsInner() *ChannelTagsInner {
	this := ChannelTagsInner{}
	return &this
}

// NewChannelTagsInnerWithDefaults instantiates a new ChannelTagsInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewChannelTagsInnerWithDefaults() *ChannelTagsInner {
	this := ChannelTagsInner{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *ChannelTagsInner) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelTagsInner) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *ChannelTagsInner) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *ChannelTagsInner) SetId(v string) {
	o.Id = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *ChannelTagsInner) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ChannelTagsInner) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *ChannelTagsInner) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *ChannelTagsInner) SetName(v string) {
	o.Name = &v
}

func (o ChannelTagsInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ChannelTagsInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	return toSerialize, nil
}

type NullableChannelTagsInner struct {
	value *ChannelTagsInner
	isSet bool
}

func (v NullableChannelTagsInner) Get() *ChannelTagsInner {
	return v.value
}

func (v *NullableChannelTagsInner) Set(val *ChannelTagsInner) {
	v.value = val
	v.isSet = true
}

func (v NullableChannelTagsInner) IsSet() bool {
	return v.isSet
}

func (v *NullableChannelTagsInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableChannelTagsInner(val *ChannelTagsInner) *NullableChannelTagsInner {
	return &NullableChannelTagsInner{value: val, isSet: true}
}

func (v NullableChannelTagsInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableChannelTagsInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


